GNU bug report logs - #29334
25.3; compiled commands don't respect special interactive expressions

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Allen Li <vianchielfaura@HIDDEN>; dated Fri, 17 Nov 2017 06:18:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.
Removed tag(s) patch and fixed. Request was from Noam Postavsky <npostavs@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Did not alter fixed versions and reopened. Request was from Debbugs Internal Request <help-debbugs@HIDDEN> to internal_control <at> debbugs.gnu.org. Full text available.
bug No longer marked as fixed in versions 27.1. Request was from Noam Postavsky <npostavs@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 29334 <at> debbugs.gnu.org:


Received: (at 29334) by debbugs.gnu.org; 7 Jan 2018 02:55:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 06 21:55:17 2018
Received: from localhost ([127.0.0.1]:38622 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eY17E-0001oc-Oq
	for submit <at> debbugs.gnu.org; Sat, 06 Jan 2018 21:55:16 -0500
Received: from mail-io0-f182.google.com ([209.85.223.182]:35769)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <npostavs@HIDDEN>)
 id 1eY17D-0001oL-Ex; Sat, 06 Jan 2018 21:55:15 -0500
Received: by mail-io0-f182.google.com with SMTP id 14so9648712iou.2;
 Sat, 06 Jan 2018 18:55:15 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=YM27nmsi348DNBHl6FzCl63TdSEjU9VuSSZxz4GK8kI=;
 b=sHVKnbCHP5KA++rA+pHLX3ZOVojfzXITHDVbiiu6TGDNLPb+k5x0QBFLpRxpTliOLZ
 jDqT0czK9vylpNus+vXOH8Q2dyerGqk0csQ5MeJpja8LnN4xeCGAlyKxNVTiPZTQhnbh
 +g6mXeJl3kBBrMy3ip/MlRbMA6QFoBt4gz+fIQWIelCwqTvBEMgiR9FMN83ahPhW56J2
 yNyMRWA2KDW0BKBpmrZIfQCAT3erkuXd+PxjrBwrEXOHs46MPQZFPMafKymxMBaNAQCg
 nGh9pKco6mFezlPJoOAa+FHofm6kEFYIOmRjJAJNBFxxPEywU3kzznUK5oIkZjMjjPyH
 anvA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:from:to:cc:subject:references:date
 :in-reply-to:message-id:user-agent:mime-version;
 bh=YM27nmsi348DNBHl6FzCl63TdSEjU9VuSSZxz4GK8kI=;
 b=ogU+iC9ZxIlMimS6jCBr2qdc6oemV/av/QpWB3vLtSkUJ25C45xEZ8kxoShkN1Qip9
 LOaEsqp1jW2zffOsioHzWqXuJWsy/P1BRsOmgHTCGBasl6mcHYk/Ym59m8XMfOXBcehR
 B2/ac2zes2OXatXaMsw7bLRxDvY7Z5qa5M4a0np7cZCFOXdzjJAJMsyOf9YxiB2ntIbZ
 EwJmZzY6SHgdaq2NqxwBshqylW1piOQnq6+Rk0FGTVh7aNKhk+Nl6qQDpf5TH+K2DMDj
 dc7ukD855YwZsZ1aG1xjuB30H+8YZ/+fZEyz6InD8d4VPMUHTOhIt+XS2ZdB1FiAU2iV
 DYfw==
X-Gm-Message-State: AKwxytf6gYU9rDrmi2xK6T2bDnwP8IOQKpI09F7ZOVGKEFwFZVeXqjm2
 Tuj2M0hjcnJfAG4JUUIXkreh3w==
X-Google-Smtp-Source: ACJfBov+OxkQDYfIQXFn6c4Jbi07mQdvtP7GE1X4ZnzVC34CkXzcb1rH0qzXtSL33INi2+IYlFd0oQ==
X-Received: by 10.107.11.221 with SMTP id 90mr8002150iol.160.1515293709694;
 Sat, 06 Jan 2018 18:55:09 -0800 (PST)
Received: from zebian ([45.2.119.34])
 by smtp.googlemail.com with ESMTPSA id v198sm1632063ita.3.2018.01.06.18.55.08
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Sat, 06 Jan 2018 18:55:08 -0800 (PST)
From: Noam Postavsky <npostavs@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#29334: 25.3;
 compiled commands don't respect special interactive expressions
References: <CAJr1M6fEjAkrvDuGZS=XvAm8w6raDmsE6TPyq89mQbJcewfUNw@HIDDEN>
 <h4o9nvl8kk.fsf@HIDDEN> <87efooz7z8.fsf@HIDDEN>
 <83vai09kgq.fsf@HIDDEN> <877eufzx8p.fsf@HIDDEN>
 <87d12qs55z.fsf@HIDDEN>
Date: Sat, 06 Jan 2018 21:55:07 -0500
In-Reply-To: <87d12qs55z.fsf@HIDDEN> (Noam Postavsky's message
 of "Wed, 03 Jan 2018 21:56:24 -0500")
Message-ID: <87bmi6qsxg.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.0.90 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 29334
Cc: 29334 <at> debbugs.gnu.org, rgm@HIDDEN, vianchielfaura@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.5 (/)

notfixed 29334 27.1
reopen 29334
tag 29334 - fixed patch
quit

Noam Postavsky <npostavs@HIDDEN> writes:

> Pushed to master.
>
> [1: ce48658191]: 2018-01-03 20:51:28 -0500
>   Fix command repetition with lexical-binding (Bug#29334)
>   https://git.savannah.gnu.org/cgit/emacs.git/commit/?id=ce48658191befb7734a7af484e368af5ed8b9447

Turns out this doesn't actually work, so I've reverted it.

https://debbugs.gnu.org/cgi/bugreport.cgi?bug=29988#11




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#29334; Package emacs. Full text available.

Message received at 29334 <at> debbugs.gnu.org:


Received: (at 29334) by debbugs.gnu.org; 4 Jan 2018 05:26:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jan 04 00:26:20 2018
Received: from localhost ([127.0.0.1]:34958 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eWy2m-0007kU-7C
	for submit <at> debbugs.gnu.org; Thu, 04 Jan 2018 00:26:20 -0500
Received: from pmta21.teksavvy.com ([76.10.157.36]:20504)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1eWy2j-0007kD-Sy
 for 29334 <at> debbugs.gnu.org; Thu, 04 Jan 2018 00:26:18 -0500
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: =?us-ascii?q?A2GDEwCAuk1a/xCds2tdHgEGDIM+gVqJS?=
 =?us-ascii?q?YYHjhMBggAzAZkLCoU1BAIChC9EFAEBAQEBAQEBAQNoKIUlAQQBViMFCws0EhQ?=
 =?us-ascii?q?YDSSKOQi0VYo+AQEBAQYCASWEE4h/ixoFkzWQHo9liAuJUYd2lwmBPDYjgU8yG?=
 =?us-ascii?q?ggwPYIqglMcGYFsI4k3AQEB?=
X-IPAS-Result: =?us-ascii?q?A2GDEwCAuk1a/xCds2tdHgEGDIM+gVqJSYYHjhMBggAzAZk?=
 =?us-ascii?q?LCoU1BAIChC9EFAEBAQEBAQEBAQNoKIUlAQQBViMFCws0EhQYDSSKOQi0VYo+A?=
 =?us-ascii?q?QEBAQYCASWEE4h/ixoFkzWQHo9liAuJUYd2lwmBPDYjgU8yGggwPYIqglMcGYF?=
 =?us-ascii?q?sI4k3AQEB?=
X-IronPort-AV: E=Sophos;i="5.45,505,1508817600"; d="scan'208";a="16791870"
Received: from 107-179-157-16.cpe.teksavvy.com (HELO ceviche.home)
 ([107.179.157.16])
 by smtp.teksavvy.com with ESMTP/TLS/DHE-RSA-AES256-GCM-SHA384;
 04 Jan 2018 00:25:55 -0500
Received: by ceviche.home (Postfix, from userid 20848)
 id 1C2BA66326; Thu,  4 Jan 2018 00:25:55 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Drew Adams <drew.adams@HIDDEN>
Subject: Re: bug#29334: 25.3;
 compiled commands don't respect special interactive expressions
Message-ID: <jwv4lo2436z.fsf-monnier+bug#29334@HIDDEN>
References: <CAJr1M6fEjAkrvDuGZS=XvAm8w6raDmsE6TPyq89mQbJcewfUNw@HIDDEN>
 <07ace48b-93b3-4b01-9f71-b69ed44492c6@default>
Date: Thu, 04 Jan 2018 00:25:55 -0500
In-Reply-To: <07ace48b-93b3-4b01-9f71-b69ed44492c6@default> (Drew Adams's
 message of "Fri, 17 Nov 2017 06:55:41 -0800 (PST)")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.3 (/)
X-Debbugs-Envelope-To: 29334
Cc: 29334 <at> debbugs.gnu.org, Allen Li <vianchielfaura@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.3 (/)

> Yes, thank you!  This is something that has bugged me
> for a while.  This change is actually a regression (or
> else on purpose?), introduced in Emacs 24.

Indeed.  As for the question in parenthesis, yes I consciously decided
to break this "ugly hack" back then, wondering how much time it would
take for people to notice it (and hoping I'd find the time/motivation
to "do it right" in the mean time).

> Hah, okay, but that was the conservative approach!  The radical one
> would be resolving this FIXME:
>
>     static void
>     fix_command (Lisp_Object input, Lisp_Object values)
>     {
>       /* FIXME: Instead of this ugly hack, we should provide a way for an
>          interactive spec to return an expression/function that will re-build the
>          args without user intervention.  */

E.g. we could allow the interactive spec to return either a list of
argument *values*, or a list of argument *expressions* (and we could
distinguish the two by having the second be a vector instead of a list,
for example).


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#29334; Package emacs. Full text available.
bug marked as fixed in version 27.1, send any further explanations to 29334 <at> debbugs.gnu.org and Allen Li <vianchielfaura@HIDDEN> Request was from Noam Postavsky <npostavs@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Added tag(s) fixed. Request was from Noam Postavsky <npostavs@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 29334 <at> debbugs.gnu.org:


Received: (at 29334) by debbugs.gnu.org; 4 Jan 2018 02:56:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 03 21:56:35 2018
Received: from localhost ([127.0.0.1]:34876 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eWvhq-000877-Pt
	for submit <at> debbugs.gnu.org; Wed, 03 Jan 2018 21:56:35 -0500
Received: from mail-it0-f45.google.com ([209.85.214.45]:39898)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <npostavs@HIDDEN>)
 id 1eWvho-00086l-EF; Wed, 03 Jan 2018 21:56:32 -0500
Received: by mail-it0-f45.google.com with SMTP id 68so768700ite.4;
 Wed, 03 Jan 2018 18:56:32 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=feARyC8AltTuMW0kJ2I78rTNI3F7xKPZA22dkvohZf4=;
 b=j6QXli66gEqMKJdOIm8t8qc6FMDoX01+PI5+q2GRgi82HicNsuBXqh9jhNJiI9/Q6u
 x8Q4SB1tP6MUzGPCVYe8wlL5XOKe2WOKS08VF67whkkGsK7nEZAay7njp+JUb8so2sd/
 +bl1E/PYiw+3Q41IZ61TZDfnG0F+5iHNePhJ33hj6d9trT9zBHHkExu6yvteAfngGbAK
 UPsstaUNWLLd/94i7++tNzPdiYBEmZuZXXdslRxLdmXqDtLpwlIV4RTufkKRP48Tnu0S
 m/kkDi3bwMwySm9PrC/0wo/OZpD1Fc9vTor1cEN/mkb6dUMqpmBUqV50YM5Te1Pr7RLf
 rO6Q==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:from:to:cc:subject:references:date
 :in-reply-to:message-id:user-agent:mime-version;
 bh=feARyC8AltTuMW0kJ2I78rTNI3F7xKPZA22dkvohZf4=;
 b=qjikEn6DbyYpXCrkJGGOoVuQq9/N1adg7dkQ2IoyajJPSOIcX43UmT7a4xbpG013F5
 0Sbt6hnNWFVbehdw1nrx7uwCAYoqB4YoE8Ds4yzmjsl7RTu7T+xC+arobwNTyC6/Hb+S
 MOu97hVijnXCe4n9KbhaSgfdfZxDHZxBOw8IyMt5cJkwg94yDOeZsNKPERnqFPz7PHbq
 vWss0jpPnBQ6dpYBVdQg0k/BowD0irRdsshcSn0vYwY6GINeSnLSpoFmOlA2o7xclRby
 BZl16JX2uUPBJ9JsZxaWe321ZTpRmT5BoW6bqVHBiDMXL0FZcVNo4D7VsqLTLGNcGwb0
 nu2Q==
X-Gm-Message-State: AKGB3mJRldBag8ORFcoVroywrDXAHVbmw/lwmUyyCmxTMkwogRgsR+cl
 m1k5LMeHFk5cLXtyyimVd68lrg==
X-Google-Smtp-Source: ACJfBotSxAS+qpSjXatr28xu9sToBIRJP3vlDVkanoPC8LrojaR6jyABeoPKtGUAxZVSEbvlpOzLAw==
X-Received: by 10.36.103.213 with SMTP id u204mr4089358itc.91.1515034586451;
 Wed, 03 Jan 2018 18:56:26 -0800 (PST)
Received: from zebian ([45.2.119.34])
 by smtp.googlemail.com with ESMTPSA id v11sm1392660itf.6.2018.01.03.18.56.24
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Wed, 03 Jan 2018 18:56:25 -0800 (PST)
From: Noam Postavsky <npostavs@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#29334: 25.3;
 compiled commands don't respect special interactive expressions
References: <CAJr1M6fEjAkrvDuGZS=XvAm8w6raDmsE6TPyq89mQbJcewfUNw@HIDDEN>
 <h4o9nvl8kk.fsf@HIDDEN> <87efooz7z8.fsf@HIDDEN>
 <83vai09kgq.fsf@HIDDEN> <877eufzx8p.fsf@HIDDEN>
Date: Wed, 03 Jan 2018 21:56:24 -0500
In-Reply-To: <877eufzx8p.fsf@HIDDEN> (Noam Postavsky's message
 of "Fri, 24 Nov 2017 07:17:58 -0500")
Message-ID: <87d12qs55z.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.0.90 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 2.0 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: tags 29334 fixed close 29334 27.1 quit Noam Postavsky
 <npostavs@HIDDEN>
 writes: > Eli Zaretskii <eliz@HIDDEN> writes: > >>> To fix this, change
 `call-interactively' so that it checks compiled >>> functions for
 lexical-binding
 as well. Then the byte-compiler can >>> preserve the source of interactive
 forms regardless of the value of >>> lexical-binding. >> >> Thanks. If no
 objections are voiced to this approach, please push it >> to the master branch.
 I think this is too radical for the release >> branch. [...] 
 Content analysis details:   (2.0 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at http://www.dnswl.org/, no
 trust [209.85.214.45 listed in list.dnswl.org]
 -0.0 RCVD_IN_MSPIKE_H3      RBL: Good reputation (+3)
 [209.85.214.45 listed in wl.mailspike.net]
 0.0 FREEMAIL_FROM Sender email is commonly abused enduser mail provider
 (npostavs[at]gmail.com)
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.2 HEADER_FROM_DIFFERENT_DOMAINS From and EnvelopeFrom 2nd level mail
 domains are different
 1.5 RCVD_IN_SORBS_WEB      RBL: SORBS: sender is an abusable web server
 [209.85.214.45 listed in dnsbl.sorbs.net]
 0.0 T_DKIM_INVALID         DKIM-Signature header exists but is not valid
 0.2 FREEMAIL_FORGED_FROMDOMAIN 2nd level domains in From and EnvelopeFrom
 freemail headers are different
 -0.0 RCVD_IN_MSPIKE_WL      Mailspike good senders
X-Debbugs-Envelope-To: 29334
Cc: 29334 <at> debbugs.gnu.org, rgm@HIDDEN, vianchielfaura@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 2.0 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  tags 29334 fixed close 29334 27.1 quit Noam Postavsky <npostavs@HIDDEN>
    writes: > Eli Zaretskii <eliz@HIDDEN> writes: > >>> To fix this, change
   `call-interactively' so that it checks compiled >>> functions for lexical-binding
    as well. Then the byte-compiler can >>> preserve the source of interactive
    forms regardless of the value of >>> lexical-binding. >> >> Thanks. If no
    objections are voiced to this approach, please push it >> to the master branch.
    I think this is too radical for the release >> branch. [...] 
 
 Content analysis details:   (2.0 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  1.5 RCVD_IN_SORBS_WEB      RBL: SORBS: sender is an abusable web server
                             [209.85.214.45 listed in dnsbl.sorbs.net]
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at http://www.dnswl.org/, no
                             trust
                             [209.85.214.45 listed in list.dnswl.org]
 -0.0 RCVD_IN_MSPIKE_H3      RBL: Good reputation (+3)
                             [209.85.214.45 listed in wl.mailspike.net]
  0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail provider
                             (npostavs[at]gmail.com)
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.2 HEADER_FROM_DIFFERENT_DOMAINS From and EnvelopeFrom 2nd level mail
                             domains are different
  0.0 T_DKIM_INVALID         DKIM-Signature header exists but is not valid
  0.2 FREEMAIL_FORGED_FROMDOMAIN 2nd level domains in From and EnvelopeFrom
                              freemail headers are different
 -0.0 RCVD_IN_MSPIKE_WL      Mailspike good senders

tags 29334 fixed
close 29334 27.1
quit

Noam Postavsky <npostavs@HIDDEN> writes:

> Eli Zaretskii <eliz@HIDDEN> writes:
>
>>> To fix this, change `call-interactively' so that it checks compiled
>>> functions for lexical-binding as well.  Then the byte-compiler can
>>> preserve the source of interactive forms regardless of the value of
>>> lexical-binding.
>>
>> Thanks.  If no objections are voiced to this approach, please push it
>> to the master branch.  I think this is too radical for the release
>> branch.

Pushed to master.

[1: ce48658191]: 2018-01-03 20:51:28 -0500
  Fix command repetition with lexical-binding (Bug#29334)
  https://git.savannah.gnu.org/cgit/emacs.git/commit/?id=ce48658191befb7734a7af484e368af5ed8b9447




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#29334; Package emacs. Full text available.

Message received at 29334 <at> debbugs.gnu.org:


Received: (at 29334) by debbugs.gnu.org; 24 Nov 2017 12:18:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 24 07:18:12 2017
Received: from localhost ([127.0.0.1]:54776 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eICvp-0001mJ-J3
	for submit <at> debbugs.gnu.org; Fri, 24 Nov 2017 07:18:09 -0500
Received: from mail-io0-f176.google.com ([209.85.223.176]:36772)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <npostavs@HIDDEN>) id 1eICvm-0001ls-TB
 for 29334 <at> debbugs.gnu.org; Fri, 24 Nov 2017 07:18:07 -0500
Received: by mail-io0-f176.google.com with SMTP id 79so21842716ioi.3
 for <29334 <at> debbugs.gnu.org>; Fri, 24 Nov 2017 04:18:06 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=atew0ij7m4rzDSzMNIv0g9jie6frTL3cQWE4pujdG74=;
 b=KeKKcnAmKum6bZeex8zGC3mxQvJr3xd2mc7mzITTgaf7nmEl3QCQEmpKDXdOQcv/pO
 Bv3F62prF+1ks8LS9U08HxydId9ZVRr5xLpT4bcBUNERcoPFJWjF4qXZkIrgavkKVVar
 XzNFRmlm23cfjFdkRM1TxwXmPZWihkFW+eeRc3ki1xv7jg1EhIb91QnbDPf2wymcTa/g
 vVIxickiFPbF5Cvf+p8oEvB/2BJO4DqOO5CtOTQAeOK7vSyYGZYDPu/WWPmWoe1LcYax
 BoGV5dujTRrwZ4L7r5gBHXUeVllqFx4EZiE1A5H1vDyTGSpruhb6diVeOuihzJXkV9gP
 L23g==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:from:to:cc:subject:references:date
 :in-reply-to:message-id:user-agent:mime-version;
 bh=atew0ij7m4rzDSzMNIv0g9jie6frTL3cQWE4pujdG74=;
 b=JPyKFiqMK+B2tJqGgNbXYlgark/MhnjcFJ21+3EUf7oqz9Bua5+oM2d3tW+UMuxbT6
 DFbpLB9PDyXAf0akvudE52vaKs4dB4Mxw+E15Y9iWDKoGyOGrK2d1qylbobepV1XUf7Q
 0DxPLpyEVxgYPUVA0XT65HHgEvpZznQNxTso0eEQ2WMJlxy5yLki2ZFgf+xKv7o0CwIt
 1KtYU3gT0Epqb/zPAseJeCu6P9tz3urXWOpqKQvr+I5xJL/Zbn9F9Nf82Nb3jYhB0r7g
 pZ7MQ+8ZdPwlZd45HSnwpXhem7ynDSSdtW8wzS0pV/mCW5v9O4PgYYEFQaEWRy3N9CqU
 QHrA==
X-Gm-Message-State: AJaThX5RN2kVynVqVSFyu8TTnMH8alZxKE0aqLgjmUmr95ETcReNuqJZ
 2LKKHUvSx0GbY5vyL+QuxaA=
X-Google-Smtp-Source: AGs4zMb5trUSgcohZGvjTp9l38DquivvoPamUcxF6IfjCwgvsEDj6H8Hs2b5uWjVdULiIaVotM7JFQ==
X-Received: by 10.107.167.206 with SMTP id q197mr29223221ioe.94.1511525881287; 
 Fri, 24 Nov 2017 04:18:01 -0800 (PST)
Received: from zebian ([45.2.119.34])
 by smtp.googlemail.com with ESMTPSA id w139sm4358911itb.5.2017.11.24.04.17.58
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Fri, 24 Nov 2017 04:17:59 -0800 (PST)
From: Noam Postavsky <npostavs@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#29334: 25.3;
 compiled commands don't respect special interactive expressions
References: <CAJr1M6fEjAkrvDuGZS=XvAm8w6raDmsE6TPyq89mQbJcewfUNw@HIDDEN>
 <h4o9nvl8kk.fsf@HIDDEN> <87efooz7z8.fsf@HIDDEN>
 <83vai09kgq.fsf@HIDDEN>
Date: Fri, 24 Nov 2017 07:17:58 -0500
In-Reply-To: <83vai09kgq.fsf@HIDDEN> (Eli Zaretskii's message of "Fri, 24 Nov
 2017 09:58:29 +0200")
Message-ID: <877eufzx8p.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.0.90 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.2 (/)
X-Debbugs-Envelope-To: 29334
Cc: 29334 <at> debbugs.gnu.org, rgm@HIDDEN, vianchielfaura@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.2 (/)

Eli Zaretskii <eliz@HIDDEN> writes:

>> To fix this, change `call-interactively' so that it checks compiled
>> functions for lexical-binding as well.  Then the byte-compiler can
>> preserve the source of interactive forms regardless of the value of
>> lexical-binding.
>
> Thanks.  If no objections are voiced to this approach, please push it
> to the master branch.  I think this is too radical for the release
> branch.

Hah, okay, but that was the conservative approach!  The radical one
would be resolving this FIXME:

    static void
    fix_command (Lisp_Object input, Lisp_Object values)
    {
      /* FIXME: Instead of this ugly hack, we should provide a way for an
         interactive spec to return an expression/function that will re-build the
         args without user intervention.  */

> P.S. Should this change be reflected in the ELisp manual somehow?

I don't see where.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#29334; Package emacs. Full text available.

Message received at 29334 <at> debbugs.gnu.org:


Received: (at 29334) by debbugs.gnu.org; 24 Nov 2017 07:59:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 24 02:59:03 2017
Received: from localhost ([127.0.0.1]:54632 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eI8t4-000443-PE
	for submit <at> debbugs.gnu.org; Fri, 24 Nov 2017 02:59:02 -0500
Received: from eggs.gnu.org ([208.118.235.92]:49970)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1eI8t3-00043a-5p
 for 29334 <at> debbugs.gnu.org; Fri, 24 Nov 2017 02:59:01 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1eI8sx-0000Qu-9x
 for 29334 <at> debbugs.gnu.org; Fri, 24 Nov 2017 02:58:56 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,T_RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:52553)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1eI8sr-0000Jo-BA; Fri, 24 Nov 2017 02:58:49 -0500
Received: from [176.228.60.248] (port=2576 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1eI8sp-0001sa-P4; Fri, 24 Nov 2017 02:58:48 -0500
Date: Fri, 24 Nov 2017 09:58:29 +0200
Message-Id: <83vai09kgq.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Noam Postavsky <npostavs@HIDDEN>
In-reply-to: <87efooz7z8.fsf@HIDDEN> (message from Noam
 Postavsky on Thu, 23 Nov 2017 22:11:23 -0500)
Subject: Re: bug#29334: 25.3;
 compiled commands don't respect special interactive expressions
References: <CAJr1M6fEjAkrvDuGZS=XvAm8w6raDmsE6TPyq89mQbJcewfUNw@HIDDEN>
 <h4o9nvl8kk.fsf@HIDDEN> <87efooz7z8.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: 29334
Cc: 29334 <at> debbugs.gnu.org, rgm@HIDDEN, vianchielfaura@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Eli Zaretskii <eliz@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.0 (-----)

> From: Noam Postavsky <npostavs@HIDDEN>
> Date: Thu, 23 Nov 2017 22:11:23 -0500
> Cc: 29334 <at> debbugs.gnu.org, Allen Li <vianchielfaura@HIDDEN>
> 
> > Bisected to a46481370, our old friend "Use lexical-binding".
> 
> How about this:
> 
> >From a8b43e98c592c84957ea304a0dc2d6423af9c5c5 Mon Sep 17 00:00:00 2001
> From: Noam Postavsky <npostavs@HIDDEN>
> Date: Thu, 23 Nov 2017 21:57:09 -0500
> Subject: [PATCH] Fix command repetition with lexical-binding (Bug#29334)
> 
> `call-interactively' relies on analyzing the source of `interactive'
> forms in order to preserve arguments like (region-end) in the command
> history, rather than just storing the resulting position.  However,
> the byte-compiler does not preserve the source of the interactive form
> when lexical-binding is in effect, because `call-interactively' would
> evaluate the form with dynamic binding in that case.
> 
> To fix this, change `call-interactively' so that it checks compiled
> functions for lexical-binding as well.  Then the byte-compiler can
> preserve the source of interactive forms regardless of the value of
> lexical-binding.

Thanks.  If no objections are voiced to this approach, please push it
to the master branch.  I think this is too radical for the release
branch.

P.S. Should this change be reflected in the ELisp manual somehow?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#29334; Package emacs. Full text available.
Added tag(s) patch. Request was from Noam Postavsky <npostavs@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 29334 <at> debbugs.gnu.org:


Received: (at 29334) by debbugs.gnu.org; 24 Nov 2017 03:11:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Nov 23 22:11:35 2017
Received: from localhost ([127.0.0.1]:54523 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eI4Os-0001sy-U1
	for submit <at> debbugs.gnu.org; Thu, 23 Nov 2017 22:11:35 -0500
Received: from mail-io0-f177.google.com ([209.85.223.177]:33267)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <npostavs@HIDDEN>)
 id 1eI4Oq-0001se-7n; Thu, 23 Nov 2017 22:11:33 -0500
Received: by mail-io0-f177.google.com with SMTP id i184so20853999ioa.0;
 Thu, 23 Nov 2017 19:11:32 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=3G6RTXJJ51PecuVaAyeePlO6xsqJWhNeaBKB9eFmVKc=;
 b=IHcx8jGOJ2fZFSg/KNw07kV61h5YJiVSG/LCX7QiBepNyQNfdcR34RZl/kQfJxCkn7
 YKoLgdKq4QJ3NimPFs1n3Eevqqg8UtEWJd55tdZxVbelufLqVGBmfyuCTag+kef8QHeK
 3qyEULPxS2xuqsVLcKk6DpwY/aAOvN9Dk8QRkmA5jX9EsI54wRknwCQKJsi9EJOcPCWt
 Lj8E6Efrbcyuwe02kcoiqlkxeOV+eIy918jMd/c4Xx7LDeTT6VjOc1RL4vEyDWwmM7O1
 In8pAgFC6hv100otJ4Dx4NAQ80H1P2LFegBymK/JUkGz6bvcK3VTBi+4PIL7ZYryaln4
 HWuQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:from:to:cc:subject:references:date
 :in-reply-to:message-id:user-agent:mime-version;
 bh=3G6RTXJJ51PecuVaAyeePlO6xsqJWhNeaBKB9eFmVKc=;
 b=J/Ar/kJPDYHVJuNC2OWPD7Ie6DM98pFaO0ByTG+W/GrPlQMp2Dnm9nK3bUO3xKPXNa
 RFVE3o14EZMfO98Q10+F4jNMKkoq1GZt7rVUsnRYfwyBAt1vQRY92Lx10xENWFGSIEZu
 xMuhYK1EED+z/T8KWgzWnfUJc5HuyJePkJXpzhoOmXOB0ZMgdqHZOQg6rg+wz7PwvffN
 bbgOxYGpcHKpPozrR4J7PgtjwZIxrtMddhX12A4CJYogn2g0RQTmZAFcbvAAq3S56OGX
 dLkUYo4YxZE/a4y7kl2SVBozh99H+VKBVrWaxIQpmfreUlvT1w4CEZhIwSTNaho5FBus
 BQ9Q==
X-Gm-Message-State: AJaThX4Xhq1o3F2I92LQrrzZY1IZ16jCPxRPFEHeByqoeh7WiYQdDruZ
 XmBL7xLgZTGxeo+m7ZQg+unj5g==
X-Google-Smtp-Source: AGs4zMYR9MN0Suz0OvgGyG+d1oJUiigvXr1skhJ2MmzX1MgYcpIsdH+ZVmRfeaYQ48Va4vDiVRgDDA==
X-Received: by 10.107.104.5 with SMTP id d5mr29297203ioc.84.1511493086383;
 Thu, 23 Nov 2017 19:11:26 -0800 (PST)
Received: from zebian ([45.2.119.34])
 by smtp.googlemail.com with ESMTPSA id o207sm3810908itc.27.2017.11.23.19.11.24
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Thu, 23 Nov 2017 19:11:25 -0800 (PST)
From: Noam Postavsky <npostavs@HIDDEN>
To: Glenn Morris <rgm@HIDDEN>
Subject: Re: bug#29334: 25.3;
 compiled commands don't respect special interactive expressions
References: <CAJr1M6fEjAkrvDuGZS=XvAm8w6raDmsE6TPyq89mQbJcewfUNw@HIDDEN>
 <h4o9nvl8kk.fsf@HIDDEN>
Date: Thu, 23 Nov 2017 22:11:23 -0500
In-Reply-To: <h4o9nvl8kk.fsf@HIDDEN> (Glenn Morris's message of
 "Tue, 21 Nov 2017 14:45:31 -0500")
Message-ID: <87efooz7z8.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.0.90 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Spam-Score: 0.2 (/)
X-Debbugs-Envelope-To: 29334
Cc: 29334 <at> debbugs.gnu.org, Allen Li <vianchielfaura@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.2 (/)

--=-=-=
Content-Type: text/plain

tags 29334 + patch
quit

Glenn Morris <rgm@HIDDEN> writes:

> Bisected to a46481370, our old friend "Use lexical-binding".

How about this:


--=-=-=
Content-Type: text/x-diff
Content-Disposition: inline;
 filename=0001-Fix-command-repetition-with-lexical-binding-Bug-2933.patch
Content-Description: patch

From a8b43e98c592c84957ea304a0dc2d6423af9c5c5 Mon Sep 17 00:00:00 2001
From: Noam Postavsky <npostavs@HIDDEN>
Date: Thu, 23 Nov 2017 21:57:09 -0500
Subject: [PATCH] Fix command repetition with lexical-binding (Bug#29334)

`call-interactively' relies on analyzing the source of `interactive'
forms in order to preserve arguments like (region-end) in the command
history, rather than just storing the resulting position.  However,
the byte-compiler does not preserve the source of the interactive form
when lexical-binding is in effect, because `call-interactively' would
evaluate the form with dynamic binding in that case.

To fix this, change `call-interactively' so that it checks compiled
functions for lexical-binding as well.  Then the byte-compiler can
preserve the source of interactive forms regardless of the value of
lexical-binding.

* src/callint.c (Fcall_interactively): Functions compiled with
lexical-binding have their arglist encoded as an integer, use this to
choose the right kind of binding for compiled functions too.
* lisp/emacs-lisp/bytecomp.el (byte-compile-lambda): Preserve the
uncompiled form of the interactive form when lexical-binding is
enabled too.
---
 lisp/emacs-lisp/bytecomp.el | 6 +-----
 src/callint.c               | 4 +++-
 2 files changed, 4 insertions(+), 6 deletions(-)

diff --git a/lisp/emacs-lisp/bytecomp.el b/lisp/emacs-lisp/bytecomp.el
index 590db570c5..e16405f09b 100644
--- a/lisp/emacs-lisp/bytecomp.el
+++ b/lisp/emacs-lisp/bytecomp.el
@@ -2823,11 +2823,7 @@ byte-compile-lambda
 		 (while (consp (cdr form))
 		   (setq form (cdr form)))
 		 (setq form (car form)))
-	       (if (and (eq (car-safe form) 'list)
-                        ;; The spec is evalled in callint.c in dynamic-scoping
-                        ;; mode, so just leaving the form unchanged would mean
-                        ;; it won't be eval'd in the right mode.
-                        (not lexical-binding))
+	       (if (eq (car-safe form) 'list)
 		   nil
 		 (setq int `(interactive ,newform)))))
 	    ((cdr int)
diff --git a/src/callint.c b/src/callint.c
index 5d88082e38..48ea9ba7a3 100644
--- a/src/callint.c
+++ b/src/callint.c
@@ -356,7 +356,9 @@ DEFUN ("call-interactively", Fcall_interactively, Scall_interactively, 1, 3, 0,
       /* Compute the arg values using the user's expression.  */
       specs = Feval (specs,
  		     CONSP (funval) && EQ (Qclosure, XCAR (funval))
-		     ? CAR_SAFE (XCDR (funval)) : Qnil);
+                     ? CAR_SAFE (XCDR (funval))
+                     : COMPILEDP (funval) && INTEGERP (AREF (funval, COMPILED_ARGLIST))
+                     ? Qt : Qnil);
       if (events != num_input_events || !NILP (record_flag))
 	{
 	  /* We should record this command on the command history.  */
-- 
2.11.0


--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#29334; Package emacs. Full text available.

Message received at 29334 <at> debbugs.gnu.org:


Received: (at 29334) by debbugs.gnu.org; 21 Nov 2017 19:45:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 21 14:45:42 2017
Received: from localhost ([127.0.0.1]:51446 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eHEUI-0002gs-2Z
	for submit <at> debbugs.gnu.org; Tue, 21 Nov 2017 14:45:42 -0500
Received: from eggs.gnu.org ([208.118.235.92]:60116)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rgm@HIDDEN>) id 1eHEUG-0002gh-8L
 for 29334 <at> debbugs.gnu.org; Tue, 21 Nov 2017 14:45:40 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <rgm@HIDDEN>) id 1eHEUA-0007oY-Fz
 for 29334 <at> debbugs.gnu.org; Tue, 21 Nov 2017 14:45:35 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-0.0 required=5.0 tests=BAYES_20,T_RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:45276)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <rgm@HIDDEN>)
 id 1eHEU8-0007nr-MM; Tue, 21 Nov 2017 14:45:32 -0500
Received: from rgm by fencepost.gnu.org with local (Exim 4.82)
 (envelope-from <rgm@HIDDEN>)
 id 1eHEU7-00057a-VC; Tue, 21 Nov 2017 14:45:32 -0500
From: Glenn Morris <rgm@HIDDEN>
To: Allen Li <vianchielfaura@HIDDEN>
Subject: Re: bug#29334: 25.3;
 compiled commands don't respect special interactive expressions
References: <CAJr1M6fEjAkrvDuGZS=XvAm8w6raDmsE6TPyq89mQbJcewfUNw@HIDDEN>
X-Spook: underground Serbian USDOJ UMTS Critical Infrastructure &
X-Ran: OG(\wneG_?I,P^2Yd:@hW+Az-uEKtG;]x.`_(Vs9h!{m34hRmOTOHI"ox-Z8Pqdv1m\O?f
X-Hue: red
X-Attribution: GM
Date: Tue, 21 Nov 2017 14:45:31 -0500
In-Reply-To: <CAJr1M6fEjAkrvDuGZS=XvAm8w6raDmsE6TPyq89mQbJcewfUNw@HIDDEN>
 (Allen Li's message of "Thu, 16 Nov 2017 22:17:25 -0800")
Message-ID: <h4o9nvl8kk.fsf@HIDDEN>
User-Agent: Gnus (www.gnus.org), GNU Emacs (www.gnu.org/software/emacs/)
MIME-Version: 1.0
Content-Type: text/plain
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: 29334
Cc: 29334 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.0 (-----)

Allen Li wrote:

> 1. emacs -Q
> 2. Mark some text in the buffer
> 3. M-x append-to-buffer RET *scratch* RET
> 4. C-x ESC ESC
>
> Expected last command:
>
> (append-to-buffer "*scratch*" (region-beginning) (region-end))
>
> Actual last command:
>
> (append-to-buffer "*scratch*" 1 145)

Bisected to a46481370, our old friend "Use lexical-binding".




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#29334; Package emacs. Full text available.
bug Marked as found in versions 24.4. Request was from Glenn Morris <rgm@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 29334 <at> debbugs.gnu.org:


Received: (at 29334) by debbugs.gnu.org; 17 Nov 2017 14:55:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 17 09:55:52 2017
Received: from localhost ([127.0.0.1]:45144 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eFi3b-00012I-Rl
	for submit <at> debbugs.gnu.org; Fri, 17 Nov 2017 09:55:52 -0500
Received: from aserp1040.oracle.com ([141.146.126.69]:16739)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <drew.adams@HIDDEN>) id 1eFi3Z-00012C-7U
 for 29334 <at> debbugs.gnu.org; Fri, 17 Nov 2017 09:55:49 -0500
Received: from aserv0022.oracle.com (aserv0022.oracle.com [141.146.126.234])
 by aserp1040.oracle.com (Sentrion-MTA-4.3.2/Sentrion-MTA-4.3.2) with ESMTP id
 vAHEth3S020953
 (version=TLSv1.2 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=OK);
 Fri, 17 Nov 2017 14:55:43 GMT
Received: from aserv0122.oracle.com (aserv0122.oracle.com [141.146.126.236])
 by aserv0022.oracle.com (8.14.4/8.14.4) with ESMTP id vAHEtheY008464
 (version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-GCM-SHA384 bits=256 verify=OK);
 Fri, 17 Nov 2017 14:55:43 GMT
Received: from abhmp0016.oracle.com (abhmp0016.oracle.com [141.146.116.22])
 by aserv0122.oracle.com (8.14.4/8.14.4) with ESMTP id vAHEtgTU024892;
 Fri, 17 Nov 2017 14:55:43 GMT
MIME-Version: 1.0
Message-ID: <07ace48b-93b3-4b01-9f71-b69ed44492c6@default>
Date: Fri, 17 Nov 2017 06:55:41 -0800 (PST)
From: Drew Adams <drew.adams@HIDDEN>
To: Allen Li <vianchielfaura@HIDDEN>, 29334 <at> debbugs.gnu.org
Subject: RE: bug#29334: 25.3; compiled commands don't respect special
 interactive expressions
References: <CAJr1M6fEjAkrvDuGZS=XvAm8w6raDmsE6TPyq89mQbJcewfUNw@HIDDEN>
In-Reply-To: <CAJr1M6fEjAkrvDuGZS=XvAm8w6raDmsE6TPyq89mQbJcewfUNw@HIDDEN>
X-Priority: 3
X-Mailer: Oracle Beehive Extensions for Outlook 2.0.1.9.1  (1003210) [OL
 16.0.4615.0 (x86)]
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Source-IP: aserv0022.oracle.com [141.146.126.234]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 29334
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

> 1. emacs -Q
> 2. Mark some text in the buffer
> 3. M-x append-to-buffer RET *scratch* RET
> 4. C-x ESC ESC
>=20
> Expected last command:
>=20
> (append-to-buffer "*scratch*" (region-beginning) (region-end))
>=20
> Actual last command:
>=20
> (append-to-buffer "*scratch*" 1 145)
>=20
> If you then go and re-evaluate append-to-buffer (thus loading the
> source version instead of the compiled version, you get
>=20
> (append-to-buffer "*scratch*" (region-beginning) (region-end))
>=20
> Thus, it looks like the compiled command doesn't handle special
> interactive forms correctly.

Yes, thank you!  This is something that has bugged me
for a while.  This change is actually a regression (or
else on purpose?), introduced in Emacs 24.  In all
Emacs releases prior to 24 it works as a user expects.

Dunno whether this bug report might be a duplicate.  It
seems unlikely that no one (including me) has reported
this before.  It reduces the utility of `C-x ESC ESC'
considerably.

An inexperienced user will likely give up altogether
trying to use such a command with `C-x ESC ESC', if
not give up on `C-x ESC ESC' entirely, through not
fully understanding.  And an experienced user has
the annoyance of having to edit the hard-coded values
to get the behavior expected.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#29334; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 17 Nov 2017 06:17:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 17 01:17:35 2017
Received: from localhost ([127.0.0.1]:44117 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1eFZy3-0003cw-Nv
	for submit <at> debbugs.gnu.org; Fri, 17 Nov 2017 01:17:35 -0500
Received: from eggs.gnu.org ([208.118.235.92]:36217)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <vianchielfaura@HIDDEN>) id 1eFZy2-0003cg-Iv
 for submit <at> debbugs.gnu.org; Fri, 17 Nov 2017 01:17:34 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <vianchielfaura@HIDDEN>) id 1eFZxw-00043e-JK
 for submit <at> debbugs.gnu.org; Fri, 17 Nov 2017 01:17:29 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.9 required=5.0 tests=BAYES_00,FREEMAIL_FROM,
 T_DKIM_INVALID autolearn=disabled version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:40858)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <vianchielfaura@HIDDEN>)
 id 1eFZxw-00043N-FS
 for submit <at> debbugs.gnu.org; Fri, 17 Nov 2017 01:17:28 -0500
Received: from eggs.gnu.org ([2001:4830:134:3::10]:55416)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <vianchielfaura@HIDDEN>) id 1eFZxv-0007Ob-I9
 for bug-gnu-emacs@HIDDEN; Fri, 17 Nov 2017 01:17:28 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <vianchielfaura@HIDDEN>) id 1eFZxu-00042r-To
 for bug-gnu-emacs@HIDDEN; Fri, 17 Nov 2017 01:17:27 -0500
Received: from mail-qt0-x232.google.com ([2607:f8b0:400d:c0d::232]:41027)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <vianchielfaura@HIDDEN>)
 id 1eFZxu-00042b-On
 for bug-gnu-emacs@HIDDEN; Fri, 17 Nov 2017 01:17:26 -0500
Received: by mail-qt0-x232.google.com with SMTP id e19so3538495qte.8
 for <bug-gnu-emacs@HIDDEN>; Thu, 16 Nov 2017 22:17:26 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:from:date:message-id:subject:to;
 bh=SqkJFdytiee1Cr/iDgn5gfNFDuBNNDCxqqjuYjXPN3w=;
 b=KgehM3ri73OZVSuc3FE564Ep2cn3nDV7l2iFh+BVaj2vOuuSUaed6zeYcI08yIRly2
 w8kZR7rcY2ag9STIQmm4cvJ7HwbfRTajbgTmOScZcyGa2Y7ndV6IIrlu+M2mqJa+A/0E
 ORLd32Rv/sJVdxtj1c3QzGgbGwngGR2xCgmON6I8o8htaDBRmVKjy/8rFBZ7pVS6M2qB
 I1P07115gqmpGQ1JpaZTJQFDDBh4Jz8jHI9brJnaKL5lRXAmgcq7Duqo6O67saJTHMdz
 Cmb2+DtJh4L0dwSN1TdrdeMUNRDECzM2uVjB6nn4IiJWf5lp/hBrdVoZUrYKEXmaDvI7
 lFDg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:from:date:message-id:subject:to;
 bh=SqkJFdytiee1Cr/iDgn5gfNFDuBNNDCxqqjuYjXPN3w=;
 b=h9qmROR0nKCnmkz07MXqs7uiIJmmS7X1TGAAClR1CEQfe1p+e/oI/byt9T+TcoDpnA
 s9q2pkYy5SdmNepUEf+WvbUI+divE3PX+2eqEC5tePJPnauQnffssu6SrFAJU87QEqSJ
 9TMVWYnT5lePxREa/VSwcb8kQX+PvgR9AvaEmMObQfAXe1cAXCjlt3mQCLqhL0TnZB85
 WpwLhiKUX2YXmIfDD7YMymjus8AQIqcewn2adn86U7FeZuGZbsedsyK+WKby6j8GrB0I
 RERlmPt61UnYu/p7NgwuQ1feHR1ZO2ivZGsAqfhvq+BrBvCXbCYBN7IrLSM7aC/Ut/s6
 gV1w==
X-Gm-Message-State: AJaThX6CHRwnOEcFffP9aW4b/LBeGX1wqlKDb1CfsuE0eS5YqBDJMx1s
 26PlUJOaQaTDiDA537QC5M/B5W688ir/dUCH+079yME7
X-Google-Smtp-Source: AGs4zMatlfBPhZwoMlTskUssG2+FYuQzP+Hy1iki9B3YQnZzQIPtvl6Zh89kNtHDEEQIC/VWNvxv6f8c3NDqxUPPZ/g=
X-Received: by 10.55.88.4 with SMTP id m4mr6565176qkb.329.1510899445802; Thu,
 16 Nov 2017 22:17:25 -0800 (PST)
MIME-Version: 1.0
Received: by 10.237.52.161 with HTTP; Thu, 16 Nov 2017 22:17:25 -0800 (PST)
From: Allen Li <vianchielfaura@HIDDEN>
Date: Thu, 16 Nov 2017 22:17:25 -0800
Message-ID: <CAJr1M6fEjAkrvDuGZS=XvAm8w6raDmsE6TPyq89mQbJcewfUNw@HIDDEN>
Subject: 25.3; compiled commands don't respect special interactive expressions
To: bug-gnu-emacs@HIDDEN
Content-Type: text/plain; charset="UTF-8"
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -4.0 (----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -4.0 (----)

Repro:

1. emacs -Q
2. Mark some text in the buffer
3. M-x append-to-buffer RET *scratch* RET
4. C-x ESC ESC

Expected last command:

(append-to-buffer "*scratch*" (region-beginning) (region-end))

Actual last command:

(append-to-buffer "*scratch*" 1 145)

If you then go and re-evaluate append-to-buffer (thus loading the
source version instead of the compiled version, you get

(append-to-buffer "*scratch*" (region-beginning) (region-end))

Thus, it looks like the compiled command doesn't handle special
interactive forms correctly.




Acknowledgement sent to Allen Li <vianchielfaura@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#29334; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Sun, 7 Jan 2018 03:00:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.